#include "graph.h"

fontdef get_font(canvas,name)
	Canvas canvas;
	char *name;
	{
	fontdef f;
	XGCValues gcvalues;

	/* It trys to load the desired font... */

	f.font=(Xv_Font)xv_find(canvas,FONT,
				FONT_NAME,name,NULL);

	/* In other case it loads the default font... */

	if(!f.font)
		{
		f.font=(Xv_Font)xv_get(frame,XV_FONT);
		fprintf(stderr,"\nFont Warning: Can't find font %s; default font loaded!\n",name);
		}

	/* It sets the font values. */

	gcvalues.font=(Font)xv_get(f.font,XV_XID);
	gcvalues.foreground=BlackPixel(dpy,DefaultScreen(dpy));
	gcvalues.background=WhitePixel(dpy,DefaultScreen(dpy));
	gcvalues.graphics_exposures=False;

	/* It makes a graphic-context linked to the font */

	f.gc=XCreateGC(dpy,RootWindow(dpy,DefaultScreen(dpy)),
		GCForeground|GCBackground|GCFont|GCGraphicsExposures,
		&gcvalues);
	return(f);
	}

Server_image get_image(dim,bits)
	short dim;
	short *bits;
	{
	return((Server_image)xv_create(NULL,SERVER_IMAGE,
			XV_HEIGHT,dim,
			XV_WIDTH,dim,
			SERVER_IMAGE_BITS,bits,
			NULL));
	}
